(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('rxjs/Observable'), require('rxjs/add/operator/map'), require('rxjs/add/observable/fromPromise'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define('ng-br-tools', ['exports', '@angular/core', '@angular/forms', 'rxjs/Observable', 'rxjs/add/operator/map', 'rxjs/add/observable/fromPromise', '@angular/common'], factory) :
	(factory((global['ng-br-tools'] = {}),global.ng.core,global.ng.forms,global.Rx,global.Rx.Observable.prototype,global.Rx.Observable,global.ng.common));
}(this, (function (exports,core,forms,Observable,map,fromPromise,common) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */
var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}








function __values(o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
}
function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

var CEP_MASK = '_____-___';
var CNPJ_MASK = '__.___.___/____-__';
var CPF_MASK = '___.___.___-__';
var DATA_MASK = 'DD/MM/AAAA';
var StringFormatter = /** @class */ (function () {
    function StringFormatter(mask, maskCharsArray) {
        var _this = this;
        this.maskCharsSet = new Set();
        this.placeholderChar = '¬';
        this.emptyString = '';
        this.caretPosition = 0;
        this.unchangeMask = mask;
        if (!maskCharsArray || maskCharsArray.length <= 0) {
            maskCharsArray = [this.getPlaceholderChar(mask)];
        }
        try {
            for (var maskCharsArray_1 = __values(maskCharsArray), maskCharsArray_1_1 = maskCharsArray_1.next(); !maskCharsArray_1_1.done; maskCharsArray_1_1 = maskCharsArray_1.next()) {
                var chr = maskCharsArray_1_1.value;
                var re = new RegExp(chr, 'gi');
                mask = mask.replace(re, this.placeholderChar);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (maskCharsArray_1_1 && !maskCharsArray_1_1.done && (_a = maskCharsArray_1.return)) _a.call(maskCharsArray_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.formattedMaskArray = mask.split(this.emptyString);
        this.unchangeMask.split(this.emptyString).forEach(function (item) { return _this.maskCharsSet.add(item); });
        var e_1, _a;
    }
    StringFormatter.maskedFormatter = function (txt, mask, maskChars) {
        if (maskChars === void 0) { maskChars = []; }
        var strFmt = StringFormatter.getStringFormatter(mask, maskChars);
        return strFmt.format(txt);
    };
    StringFormatter.getStringFormatter = function (mask, maskChars) {
        if (maskChars === void 0) { maskChars = []; }
        return new StringFormatter(mask, maskChars);
    };
    StringFormatter.clearFormat = function (txt, mask, maskChars) {
        if (maskChars === void 0) { maskChars = []; }
        var strFmt = StringFormatter.getStringFormatter(mask, maskChars);
        return strFmt.stripMask(txt);
    };
    StringFormatter.prototype.stripMask = function (maskedTxt) {
        var _this = this;
        return __spread(maskedTxt.split(this.emptyString)).filter(function (char) { return (!_this.maskCharsSet.has(char)); }).join(this.emptyString);
    };
    StringFormatter.prototype.getCaretPosition = function () {
        return this.caretPosition;
    };
    StringFormatter.prototype.format = function (txt) {
        var _this = this;
        this.caretPosition = 0;
        var inputArray = this.stripMask(txt).split(this.emptyString);
        var formattedStr = this.formattedMaskArray.map(function (char, index) {
            if (char !== _this.placeholderChar) {
                return char;
            }
            if (inputArray.length === 0) {
                return char;
            }
            return inputArray.shift();
        }).join(this.emptyString);
        var idx = formattedStr.indexOf(this.placeholderChar);
        if (idx !== -1) {
            this.caretPosition = idx;
            formattedStr = formattedStr.substring(0, idx) + this.unchangeMask.substr(idx);
        }
        else {
            this.caretPosition = this.unchangeMask.length;
        }
        return formattedStr;
    };
    StringFormatter.prototype.getPlaceholderChar = function (str) {
        var strCountMap = new Map();
        var maxKey = this.emptyString;
        try {
            for (var str_1 = __values(str), str_1_1 = str_1.next(); !str_1_1.done; str_1_1 = str_1.next()) {
                var key = str_1_1.value;
                if (!strCountMap.has(key)) {
                    strCountMap.set(key, 1);
                }
                else {
                    strCountMap.set(key, strCountMap.get(key) + 1);
                }
                if (maxKey === this.emptyString || strCountMap.get(maxKey) < strCountMap.get(key)) {
                    maxKey = key;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (str_1_1 && !str_1_1.done && (_a = str_1.return)) _a.call(str_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return maxKey;
        var e_2, _a;
    };
    return StringFormatter;
}());
var MaskPatternDirective = /** @class */ (function () {
    function MaskPatternDirective(el) {
        this.el = el;
        this.showPlaceholder = true;
    }
    MaskPatternDirective.prototype.ngOnInit = function () {
        if (this.showPlaceholder && !this.el.nativeElement.placeholder) {
            this.el.nativeElement.placeholder = this.pattern;
        }
    };
    MaskPatternDirective.prototype.onInput = function (event) {
        var input = ((event.target));
        var oldStart = input.selectionStart;
        var oldEnd = input.selectionEnd;
        var maskChars = [];
        if (this.maskChars) {
            maskChars = maskChars.concat(this.maskChars.split(','));
        }
        var strFmt = StringFormatter.getStringFormatter(this.pattern, maskChars);
        input.value = strFmt.format(input.value);
        if (oldEnd + 1 === strFmt.getCaretPosition()) {
            oldStart += 1;
            oldEnd += 1;
        }
        input.selectionStart = oldStart;
        input.selectionEnd = oldEnd;
    };
    return MaskPatternDirective;
}());
MaskPatternDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsMaskPattern]'
            },] },
];
MaskPatternDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
]; };
MaskPatternDirective.propDecorators = {
    "pattern": [{ type: core.Input, args: ['ngBrToolsMaskPattern',] },],
    "showPlaceholder": [{ type: core.Input, args: ['ngBrToolsShowPlacholder',] },],
    "maskChars": [{ type: core.Input, args: ['ngBrToolsMaskChars',] },],
    "onInput": [{ type: core.HostListener, args: ['keyup', ['$event'],] },],
};
var MaskPatternPipe = /** @class */ (function () {
    function MaskPatternPipe() {
    }
    MaskPatternPipe.prototype.transform = function (value, mask) {
        return StringFormatter.maskedFormatter(value, mask);
    };
    return MaskPatternPipe;
}());
MaskPatternPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'ngBrToolsMaskPatternPipe'
            },] },
];
MaskPatternPipe.ctorParameters = function () { return []; };
var CpfPatternDirective = /** @class */ (function (_super) {
    __extends(CpfPatternDirective, _super);
    function CpfPatternDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CpfPatternDirective.prototype.ngOnInit = function () {
        this.pattern = CPF_MASK;
        _super.prototype.ngOnInit.call(this);
    };
    return CpfPatternDirective;
}(MaskPatternDirective));
CpfPatternDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsCpfPattern]'
            },] },
];
CpfPatternDirective.ctorParameters = function () { return []; };
var CpfPatternPipe = /** @class */ (function (_super) {
    __extends(CpfPatternPipe, _super);
    function CpfPatternPipe() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CpfPatternPipe.prototype.transform = function (value) {
        return _super.prototype.transform.call(this, value, CPF_MASK);
    };
    return CpfPatternPipe;
}(MaskPatternPipe));
CpfPatternPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'ngBrToolsCpfPatternPipe'
            },] },
];
CpfPatternPipe.ctorParameters = function () { return []; };
var Documento = {
    CPF: 0,
    CNPJ: 1,
};
Documento[Documento.CPF] = "CPF";
Documento[Documento.CNPJ] = "CNPJ";
var BrValidator = /** @class */ (function () {
    function BrValidator(numero, tipo) {
        this.documento = {
            tipo: tipo,
            numeroCompleto: numero,
            numero: '',
            digito1: '',
            digito2: ''
        };
        if (!numero || numero.length === 0) {
            this.documento.numeroCompleto = '';
            return;
        }
        this.documento.numero = numero.substr(0, numero.length - 2);
        this.documento.digito1 = numero.substr(numero.length - 2, 1);
        this.documento.digito2 = numero.substr(numero.length - 1, 1);
    }
    BrValidator.validaCpf = function (cpf) {
        var brValidatorUtils = new BrValidator(cpf, Documento.CPF);
        return brValidatorUtils.isValid();
    };
    BrValidator.validaCnpj = function (cnpj) {
        var brValidatorUtils = new BrValidator(cnpj, Documento.CNPJ);
        return brValidatorUtils.isValid();
    };
    BrValidator.prototype.isValid = function () {
        switch (this.documento.tipo) {
            case Documento.CPF:
                return this.isValidCpf();
            case Documento.CNPJ:
                return this.isValidCnpj();
        }
    };
    BrValidator.prototype.isValidCpf = function () {
        if (this.documento.numeroCompleto.length !== 11) {
            return false;
        }
        if (this.getInvalidsCpfs().has(this.documento.numeroCompleto)) {
            return false;
        }
        return this.documento.numeroCompleto ===
            (this.documento.numero + this.getDigitoVerificador());
    };
    BrValidator.prototype.isValidCnpj = function () {
        if (this.documento.numeroCompleto.length !== 14) {
            return false;
        }
        if (this.getInvalidsCnpjs().has(this.documento.numeroCompleto)) {
            return false;
        }
        return this.documento.numeroCompleto ===
            (this.documento.numero + this.getDigitoVerificador());
    };
    BrValidator.prototype.getDigitoVerificador = function () {
        var digito1 = this.calculaDigitoVerificador(this.documento.numero);
        var digito2 = this.calculaDigitoVerificador(this.documento.numero + digito1);
        return digito1 + digito2;
    };
    BrValidator.prototype.calculaDigitoVerificador = function (numero) {
        var tblPesos = [];
        switch (this.documento.tipo) {
            case Documento.CPF:
                tblPesos = this.getCpfTable().reverse();
                break;
            case Documento.CNPJ:
                tblPesos = this.getCnpjTable().reverse();
                break;
        }
        var somatorio = numero.split('').reverse().map(function (char, i) {
            return Number(char) * tblPesos[i];
        }).reduce(function (sum, current) { return sum + current; });
        var resto = somatorio % 11;
        var digito = 11 - resto;
        if (digito > 9) {
            digito = 0;
        }
        return String(digito);
    };
    BrValidator.prototype.getCpfTable = function () {
        return [11, 10, 9, 8, 7, 6, 5, 4, 3, 2];
    };
    BrValidator.prototype.getCnpjTable = function () {
        return [6, 5, 4, 3, 2, 9, 8, 7, 6, 5, 4, 3, 2];
    };
    BrValidator.prototype.getInvalidsCpfs = function () {
        return new Set(['00000000000', '11111111111', '22222222222', '33333333333',
            '44444444444', '55555555555', '66666666666', '77777777777', '88888888888',
            '99999999999']);
    };
    BrValidator.prototype.getInvalidsCnpjs = function () {
        return new Set(['00000000000000', '11111111111111', '22222222222222', '33333333333333',
            '44444444444444', '55555555555555', '66666666666666', '77777777777777',
            '88888888888888', '99999999999999']);
    };
    return BrValidator;
}());
var CPFValidator = /** @class */ (function () {
    function CPFValidator() {
    }
    CPFValidator.prototype.validate = function (c) {
        if (!(c.value && c.value.length > 0)) {
            return null;
        }
        var value = c.value.split('').filter(function (char) { return !isNaN(Number(char)); }).join('');
        if (BrValidator.validaCpf(value)) {
            return null;
        }
        return { 'cpf': true };
    };
    return CPFValidator;
}());
CPFValidator.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsCpfValidator][ngModel],[ngBrToolsCpfValidator][formControl],[ngBrToolsCpfValidator][formControlName]',
                providers: [
                    {
                        provide: forms.NG_VALIDATORS,
                        useExisting: core.forwardRef(function () { return CPFValidator; }),
                        multi: true
                    }
                ]
            },] },
];
CPFValidator.ctorParameters = function () { return []; };
var CnpjPatternDirective = /** @class */ (function (_super) {
    __extends(CnpjPatternDirective, _super);
    function CnpjPatternDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CnpjPatternDirective.prototype.ngOnInit = function () {
        this.pattern = CNPJ_MASK;
        _super.prototype.ngOnInit.call(this);
    };
    return CnpjPatternDirective;
}(MaskPatternDirective));
CnpjPatternDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsCnpjPattern]'
            },] },
];
CnpjPatternDirective.ctorParameters = function () { return []; };
var CnpjPatternPipe = /** @class */ (function (_super) {
    __extends(CnpjPatternPipe, _super);
    function CnpjPatternPipe() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CnpjPatternPipe.prototype.transform = function (value) {
        return _super.prototype.transform.call(this, value, CNPJ_MASK);
    };
    return CnpjPatternPipe;
}(MaskPatternPipe));
CnpjPatternPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'ngBrToolsCnpjPatternPipe'
            },] },
];
CnpjPatternPipe.ctorParameters = function () { return []; };
var CNPJValidator = /** @class */ (function () {
    function CNPJValidator() {
    }
    CNPJValidator.prototype.validate = function (c) {
        if (!(c.value && c.value.length > 0)) {
            return null;
        }
        var value = c.value.split('').filter(function (char) { return !isNaN(Number(char)); }).join('');
        if (BrValidator.validaCnpj(value)) {
            return null;
        }
        return { 'cnpj': true };
    };
    return CNPJValidator;
}());
CNPJValidator.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsCnpjValidator][ngModel],[ngBrToolsCnpjValidator][formControl],[ngBrToolsCnpjValidator][formControlName]',
                providers: [
                    {
                        provide: forms.NG_VALIDATORS,
                        useExisting: core.forwardRef(function () { return CNPJValidator; }),
                        multi: true
                    }
                ]
            },] },
];
CNPJValidator.ctorParameters = function () { return []; };
var ESTADO_SERVICE = new core.InjectionToken('estado.service');
var EstadoServiceFactory = function (estadoService) {
    estadoService.init();
    return estadoService;
};
var LstEstadoDirective = /** @class */ (function () {
    function LstEstadoDirective(el, estadoService) {
        this.el = el;
        this.orderBy = 'nome';
        this.onEstados = new core.EventEmitter();
        this._estadoService = estadoService;
    }
    LstEstadoDirective.prototype.ngOnInit = function () {
        var _this = this;
        var resp = this._estadoService.buscaEstados();
        if (resp instanceof Promise) {
            resp = Observable.Observable.fromPromise(((resp)));
        }
        ((resp)).map(function (estados) {
            return _this._sortEstados(estados, _this.orderBy);
        }).subscribe(function (e) { return _this.onEstados.emit(e); });
    };
    LstEstadoDirective.prototype._sortEstados = function (lst, por) {
        if (por === void 0) { por = 'nome'; }
        if (lst.length <= 1) {
            return lst;
        }
        if (por === 'nome') {
            return lst.slice(0).sort(function (e1, e2) {
                if (e1.nome === e2.nome) {
                    return 0;
                }
                return (e1.nome < e2.nome) ? -1 : 1;
            });
        }
        else if (por === 'sigla') {
            return lst.slice(0).sort(function (e1, e2) {
                if (e1.sigla === e2.sigla) {
                    return 0;
                }
                return (e1.sigla < e2.sigla) ? -1 : 1;
            });
        }
    };
    return LstEstadoDirective;
}());
LstEstadoDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsListEstados]'
            },] },
];
LstEstadoDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: undefined, decorators: [{ type: core.Inject, args: [ESTADO_SERVICE,] },] },
]; };
LstEstadoDirective.propDecorators = {
    "orderBy": [{ type: core.Input, args: ['ngBrToolsOrderBy',] },],
    "onEstados": [{ type: core.Output, args: ['ngBrToolsListEstados',] },],
};
var Estado = /** @class */ (function () {
    function Estado(nome, sigla, bandeira) {
        this.nome = nome;
        this.sigla = sigla;
        this.bandeira = bandeira;
    }
    return Estado;
}());
var CepPatternDirective = /** @class */ (function (_super) {
    __extends(CepPatternDirective, _super);
    function CepPatternDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CepPatternDirective.prototype.ngOnInit = function () {
        this.pattern = CEP_MASK;
        _super.prototype.ngOnInit.call(this);
    };
    return CepPatternDirective;
}(MaskPatternDirective));
CepPatternDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsCepPattern]'
            },] },
];
CepPatternDirective.ctorParameters = function () { return []; };
var CepPatternPipe = /** @class */ (function (_super) {
    __extends(CepPatternPipe, _super);
    function CepPatternPipe() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CepPatternPipe.prototype.transform = function (value) {
        return _super.prototype.transform.call(this, value, CEP_MASK);
    };
    return CepPatternPipe;
}(MaskPatternPipe));
CepPatternPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'ngBrToolsCepPatternPipe'
            },] },
];
CepPatternPipe.ctorParameters = function () { return []; };
var CEP_SERVICE = new core.InjectionToken('cep.service');
var CepServiceFactory = function (cepService) {
    cepService.init();
    return cepService;
};
var CepSearchDirective = /** @class */ (function () {
    function CepSearchDirective(cepEl, cepService) {
        this.cepEl = cepEl;
        this.onEndereco = new core.EventEmitter();
        this.onError = new core.EventEmitter();
        this._cepService = cepService;
    }
    CepSearchDirective.prototype.onInput = function (e) {
        var cepInput = ((e.target));
        var pattern;
        if (cepInput.hasAttribute('ngBrToolsMaskPattern')) {
            pattern = cepInput.getAttribute('ngBrToolsMaskPattern');
        }
        else {
            pattern = CEP_MASK;
        }
        var cepClear = StringFormatter.clearFormat(cepInput.value, pattern);
        if (cepClear.length === 8) {
            this.doSearch(cepClear);
        }
    };
    CepSearchDirective.prototype.doSearch = function (cep) {
        var _this = this;
        var resp = this._cepService.buscaCep(cep);
        if (resp instanceof Observable.Observable) {
            ((resp)).subscribe(function (e) {
                _this.onEndereco.emit(e);
            }, function (err) {
                _this.onError.emit(err);
            });
        }
        else {
            ((resp))
                .then(function (e) { return _this.onEndereco.emit(e); })
                .catch(function (err) {
                _this.onError.emit(err);
            });
        }
    };
    return CepSearchDirective;
}());
CepSearchDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsCepSearch]'
            },] },
];
CepSearchDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: undefined, decorators: [{ type: core.Inject, args: [CEP_SERVICE,] },] },
]; };
CepSearchDirective.propDecorators = {
    "onEndereco": [{ type: core.Output },],
    "onError": [{ type: core.Output },],
    "onInput": [{ type: core.HostListener, args: ['input', ['$event'],] },],
};
var Endereco = /** @class */ (function () {
    function Endereco(endereco, bairro, cep, cidade, complemento, complemento2, uf, id) {
        this.endereco = endereco;
        this.bairro = bairro;
        this.cep = cep;
        this.cidade = cidade;
        this.complemento = complemento;
        this.complemento2 = complemento2;
        this.uf = uf;
        this.id = id;
    }
    return Endereco;
}());
var DataPatternDirective = /** @class */ (function (_super) {
    __extends(DataPatternDirective, _super);
    function DataPatternDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DataPatternDirective.prototype.ngOnInit = function () {
        this.pattern = DATA_MASK;
        this.maskChars = 'D,M,A';
        _super.prototype.ngOnInit.call(this);
    };
    return DataPatternDirective;
}(MaskPatternDirective));
DataPatternDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[ngBrToolsDataPattern]'
            },] },
];
DataPatternDirective.ctorParameters = function () { return []; };
var DataPatternPipe = /** @class */ (function () {
    function DataPatternPipe() {
    }
    DataPatternPipe.prototype.transform = function (value) {
        return StringFormatter.maskedFormatter(value, DATA_MASK, ['D', 'M', 'A']);
    };
    return DataPatternPipe;
}());
DataPatternPipe.decorators = [
    { type: core.Pipe, args: [{
                name: 'data-pattern'
            },] },
];
DataPatternPipe.ctorParameters = function () { return []; };
var NgBrToolsValidators = /** @class */ (function () {
    function NgBrToolsValidators() {
    }
    NgBrToolsValidators.cpfValidator = function (control) {
        var validator = new CPFValidator();
        return validator.validate(control);
    };
    NgBrToolsValidators.cnpjValidator = function (control) {
        var validator = new CNPJValidator();
        return validator.validate(control);
    };
    return NgBrToolsValidators;
}());
var NgBrToolsModule = /** @class */ (function () {
    function NgBrToolsModule() {
    }
    return NgBrToolsModule;
}());
NgBrToolsModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [
                    MaskPatternDirective,
                    CepPatternDirective,
                    CepSearchDirective,
                    CpfPatternDirective,
                    CnpjPatternDirective,
                    DataPatternDirective,
                    LstEstadoDirective,
                    MaskPatternPipe,
                    CepPatternPipe,
                    CpfPatternPipe,
                    CnpjPatternPipe,
                    DataPatternPipe,
                    CPFValidator,
                    CNPJValidator,
                ],
                imports: [
                    common.CommonModule,
                ],
                providers: [],
                exports: [
                    MaskPatternDirective,
                    CepPatternDirective,
                    CepSearchDirective,
                    CpfPatternDirective,
                    CnpjPatternDirective,
                    DataPatternDirective,
                    LstEstadoDirective,
                    MaskPatternPipe,
                    CepPatternPipe,
                    CpfPatternPipe,
                    CnpjPatternPipe,
                    DataPatternPipe,
                    CPFValidator,
                    CNPJValidator,
                ],
            },] },
];
NgBrToolsModule.ctorParameters = function () { return []; };

exports.MaskPatternDirective = MaskPatternDirective;
exports.MaskPatternPipe = MaskPatternPipe;
exports.CpfPatternDirective = CpfPatternDirective;
exports.CpfPatternPipe = CpfPatternPipe;
exports.CPFValidator = CPFValidator;
exports.CnpjPatternDirective = CnpjPatternDirective;
exports.CnpjPatternPipe = CnpjPatternPipe;
exports.CNPJValidator = CNPJValidator;
exports.LstEstadoDirective = LstEstadoDirective;
exports.ESTADO_SERVICE = ESTADO_SERVICE;
exports.EstadoServiceFactory = EstadoServiceFactory;
exports.Estado = Estado;
exports.CepPatternDirective = CepPatternDirective;
exports.CepPatternPipe = CepPatternPipe;
exports.CepSearchDirective = CepSearchDirective;
exports.CEP_SERVICE = CEP_SERVICE;
exports.CepServiceFactory = CepServiceFactory;
exports.Endereco = Endereco;
exports.DataPatternDirective = DataPatternDirective;
exports.DataPatternPipe = DataPatternPipe;
exports.NgBrToolsValidators = NgBrToolsValidators;
exports.NgBrToolsModule = NgBrToolsModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-br-tools.umd.js.map
